/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with {library}; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package ch.hortis.sonar.service;

/*import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.xml.namespace.NamespaceContext;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.apache.xml.serialize.OutputFormat;
import org.apache.xml.serialize.XMLSerializer;
import org.codehaus.plexus.util.StringOutputStream;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import ch.hortis.sonar.jpa.Persistence;
import ch.hortis.sonar.model.JdbcData;
import ch.hortis.sonar.model.Rule;*/

public class RulesParamsParser {
  /*
  private Persistence persist;
  private Map<String,List<RuleParameter>> parsedParams = new HashMap<String, List<RuleParameter>>();
  
  private RulesParamsParser( Persistence persist ) {
    this.persist = persist;
  }
  
  private void generateMigrationScript() throws Exception {
    parseCSXDocs();
    parsePMDXDocs();
    EntityManager manager = persist.getNewEntityManager();
    RulesService srv = new RulesService( manager );
    
    Collection<Rule> rules = srv.getRules();
    for (Rule rule : rules) {
      getRuleParams( rule );
    }
    manager.close();
  }
  
  private void parsePMDXDocs() throws Exception {
    List<File> pmdXdocs = new ArrayList<File>();
    pmdXdocs.add( new File("../pmd/rulesets/basic.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/basic-jsf.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/basic-jsp.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/braces.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/clone.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/codesize.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/controversial.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/coupling.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/design.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/finalizers.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/imports.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/j2ee.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/javabeans.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/logging-jakarta-commons.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/logging-java.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/naming.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/optimizations.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/scratchpad.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/strictexception.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/strings.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/sunsecure.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/typeresolution.xml"));
    pmdXdocs.add( new File("../pmd/rulesets/unusedcode.xml"));
    for (File xdoc : pmdXdocs) {

      DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
      factory.setNamespaceAware(true);
      DocumentBuilder builder = factory.newDocumentBuilder();
      Document document = builder.parse(xdoc);
      XPathFactory fact = XPathFactory.newInstance();
      XPath xpath = fact.newXPath();
      NamespaceContext ctx = new NamespaceContext() {
        public String getNamespaceURI(String prefix) {
          if ( prefix.equals("pmd")) {
            return "http://pmd.sf.net/ruleset/1.0.0";
          }
          return null;
        }
        public String getPrefix(String arg0) {
          return null;
        }
        public Iterator getPrefixes(String arg0) {
          return null;
        }
      };
      xpath.setNamespaceContext(ctx);
      
      NodeList rules = (NodeList)xpath.evaluate("/pmd:ruleset/pmd:rule", document, XPathConstants.NODESET);
      for ( int i = 0; i < rules.getLength(); i++ ) {
        Node rule = rules.item(i);

        String ruleName = xpath.evaluate( "@name", rule );
        String ruleConfigKey = "rulesets/" + xdoc.getName() + "/" + ruleName;
        NodeList properties = (NodeList)xpath.evaluate( "pmd:properties/pmd:property[not(@name='xpath')]", rule, XPathConstants.NODESET );
        if ( properties.getLength() > 0 ) {
          List<RuleParameter> params = getParamsList(ruleConfigKey);
          for ( int k = 0; k < properties.getLength(); k++ ) {
            Node property = properties.item(k);
            RuleParameter param = new RuleParameter();
            params.add( param );
            param.name = xpath.evaluate( "@name", property );
            param.description = xpath.evaluate( "@description", property );
            if ( param.description == null || param.description.equals( "" ) ) {
              param.description = "No description provided";
            }
            getPMDParamTypeAndDefaultValue( property, param, xpath );
          }
        }
      }
    }
  }
  
  private void getPMDParamTypeAndDefaultValue( Node property, RuleParameter param, XPath xpath ) throws Exception{
    String defaultValue = xpath.evaluate( "pmd:value/text()", property );
    if ( defaultValue == null || defaultValue.equals("")) {
      defaultValue = xpath.evaluate( "@value", property );
    }
    param.defaultValue = defaultValue;
    if ( defaultValue.equals( "true" ) || defaultValue.equals( "false" ) ) {
      param.type = "b";
    }
    try {
      Integer.parseInt(defaultValue);
      param.type = "i";
    } catch ( NumberFormatException ex ) {
    }
    if ( defaultValue.indexOf( "," ) != -1 ) {
      param.type = "s[" + getParamTokens(defaultValue) + "]";
      param.defaultValue = getParamTokens(param.defaultValue);
    }
    if ( param.type == null ) {
      param.type = "s";
    }
  }
  
  private void parseCSXDocs() throws Exception {
    List<File> csXdocs = new ArrayList<File>();
    csXdocs.add( new File("../checkstyle/src/xdocs/config_blocks.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_coding.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_design.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_duplicates.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_header.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_imports.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_j2ee.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_javadoc.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_metrics.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_misc.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_modifier.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_reporting.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_sizes.xml"));
    csXdocs.add( new File("../checkstyle/src/xdocs/config_whitespace.xml"));
    
    for (File xdoc : csXdocs) {
      
      XPath xpath = XPathFactory.newInstance().newXPath();
      InputSource inputSource = new InputSource(new FileInputStream(xdoc));
      NodeList sections = (NodeList) xpath.evaluate("/document/body/section", inputSource, XPathConstants.NODESET);

      for ( int i = 0; i < sections.getLength(); i++ ) {
        Node section = sections.item(i);
        String ruleName = xpath.evaluate( "@name", section );
        Element propEl = (Element)xpath.evaluate( "subsection[@name='Properties']", section, XPathConstants.NODE );
        String parentModule = xpath.evaluate( "subsection[@name='Parent Module']/p/a/text()", section );
        
        if ( xdoc.getPath().endsWith("config_j2ee.xml") ) {
          ruleName = "j2ee/" + ruleName; 
        }
        String ruleConfigKey = "Checker." + parentModule + "." + ruleName;
        if ( parentModule.equals( "Checker" ) ) {
          ruleConfigKey = parentModule + "." + ruleName;
        }

        if ( propEl != null ) {
          List<RuleParameter> params = getParamsList(ruleConfigKey);
          NodeList propsTr = (NodeList) xpath.evaluate( "table/tr", propEl, XPathConstants.NODESET);
          // first header tr skipped
          for ( int j = 1; j < propsTr.getLength(); j++ ) {
            Node tr = propsTr.item(j);
            NodeList cells = (NodeList) xpath.evaluate( "td", tr, XPathConstants.NODESET);
            RuleParameter param = new RuleParameter();
            params.add( param );
            param.name = xpath.evaluate( "text()", cells.item(0) );

            getCSParamDescription(cells, param);
            getCSParamType(xpath, ruleConfigKey, cells, param);
            getCSParamDefaultValue(xpath, cells, ruleConfigKey, param);
          }
        }
      }
    }
  }

  private List<RuleParameter> getParamsList(String ruleConfigKey) {
    List<RuleParameter> params = parsedParams.get( ruleConfigKey );
    if ( params == null ) {
      params = new ArrayList<RuleParameter>();
      parsedParams.put( ruleConfigKey, params);
    }
    return params;
  }

  private void getCSParamDescription(NodeList cells, RuleParameter param)
      throws IOException {
    StringOutputStream out = new StringOutputStream();
    OutputFormat frmt = new OutputFormat();
    frmt.setOmitXMLDeclaration(true);
    XMLSerializer s = new XMLSerializer(out,frmt);
    s.serialize((Element)cells.item(1));
    String description = out.toString();
    description = description.replaceAll( "<span class=\"code\">", "");
    description = description.replaceAll( "</span>", "");
    description = description.replaceAll( "<td>", "");
    description = description.replaceAll( "</td>", "");
    
    if ( description.contains( "\n" )  ) {
      String[] descrLines = description.split( "\n" );
      description = "";
      for (String line : descrLines) {
        description += line.trim() + " ";
      }
      description = description.trim();
    }
    param.description = description;
  }

  private void getCSParamType(XPath xpath, String ruleConfigKey,
      NodeList cells, RuleParameter param) throws XPathExpressionException {
    String type = xpath.evaluate( "text()", cells.item(2) );
    NodeList aTags = (NodeList)xpath.evaluate( "a", cells.item(2), XPathConstants.NODESET );
    if ( aTags.getLength() > 1 ) {
      String commaTokens = getParamTokens(xpath, cells.item(2) );
      param.type = "s[" + commaTokens + "]";
    } else {
      type = xpath.evaluate( "a/@href", cells.item(2) );
      if ( type.equalsIgnoreCase( "property_types.html#integer" ) ||
           type.equalsIgnoreCase( "property_types.html#int" ) ) {
        param.type = "i";
      } else if ( type.equalsIgnoreCase( "property_types.html#boolean" ) ) {
        param.type = "b";
      } else if ( type.equalsIgnoreCase( "property_types.html#block" ) ) {
        param.type = "s[text,stmt]";
      } else if ( type.equalsIgnoreCase( "property_types.html#lcurly" ) ) {
        param.type = "s[eol,nl,nlow]";
      } else if ( type.equalsIgnoreCase( "property_types.html#rcurly" ) ) {
        param.type = "s[same,alone]";
      } else if ( type.equalsIgnoreCase( "property_types.html#scope" ) ) {
        param.type = "s[nothing,public,protected,package,private,anoninner]";
      } else if ( type.equalsIgnoreCase( "property_types.html#severity" ) ) {
        param.type = "s[ignore,info,warning,error]";
      } else if ( type.equalsIgnoreCase( "property_types.html#string" ) ) {
        param.type = "s";
      } else if ( type.equalsIgnoreCase( "property_types.html#regexp" ) ) {
        param.type = "r";
      } else if ( type.equalsIgnoreCase( "property_types.html#stringset" ) ) {
        param.type = "s{}";
      } else if ( type.equalsIgnoreCase( "api/com/puppycrawl/tools/checkstyle/api/TokenTypes.html" ) ) {
        param.type = "s{}";
      } else if ( type.equalsIgnoreCase( "property_types.html#persistence" ) ) {
        param.type = "s[bean,container,mixed]";
      } else if ( type.equalsIgnoreCase( "property_types.html#intSet" ) ) {
        param.type = "i{}";
      } else if ( type.equalsIgnoreCase( "property_types.html#parenPad" ) ) {
        param.type = "s[nospace,space]";
      } else if ( type.equalsIgnoreCase( "property_types.html#wrapOp" ) ) {
        param.type = "s[nl,eol]";
      } else {
        throw new IllegalArgumentException("Unknown param type " + type + " " + param.name + " " +ruleConfigKey);
      }
    }
  }

  private void getCSParamDefaultValue(XPath xpath, NodeList cells, String ruleConfigKey,
      RuleParameter param) throws XPathExpressionException {
    String defaultValue = xpath.evaluate( "span[@class='default']/text()", cells.item(3) );
    if ( defaultValue == null || defaultValue.equals( "" ) ) {
      defaultValue = xpath.evaluate( "text()", cells.item(3) );
    }
    if ( param.type.startsWith( "s[" ) && !defaultValue.equals("all tokens") ) {
      defaultValue = getParamTokens(xpath, cells.item(3) );
    } else if ( param.type.startsWith( "s[" ) && defaultValue.equals("all tokens") ) {
      defaultValue = getParamTokens(xpath, cells.item(2) );
    } else if ( defaultValue.equals("(not applied)") ||
                defaultValue.equals("(not set)") || 
                defaultValue.equals( "{}") ||
                defaultValue.equals( "empty" ) ||
                defaultValue.equals( "empty set" ) ||
                defaultValue.equals( "null" ) ||
                defaultValue.equals( "\"\"" ) ||
                defaultValue.equals( "" ) ) {
      defaultValue = ""; // NO VALUE
    } else if ( defaultValue.equalsIgnoreCase( "java.lang.Integer.MAX_VALUE" ) ) {  
      defaultValue = new Integer( Integer.MAX_VALUE ).toString();
    } else if ( param.type.startsWith( "s{" ) ) {
      defaultValue = getParamTokens( xpath, cells.item(3) );
    } else if ( param.type.startsWith( "i{" ) ) {
      defaultValue = getParamTokens( defaultValue );
    } else if ( param.type.equals( "i" ) || 
                param.type.equals( "b" ) ||
                param.type.equals( "r" ) || 
                param.type.equals( "s" ) ) {
        // ok default value not in an span default tag
    } else {
      throw new IllegalArgumentException("Unknown param default value " + defaultValue + " " + param.name + " " +ruleConfigKey);
    }
    param.defaultValue = defaultValue.replace( "\"", "");
  }
  
  private String getParamTokens(String tokens) throws XPathExpressionException {
    String commaTokens = "";
    String[] tokensSplitted = tokens.split( "," );
    for ( int k = 0; k < tokensSplitted.length; k++ ) {
      String token = tokensSplitted[k].trim();
      token = token.replace( "\"", "");
      commaTokens += token + ",";
    }
    commaTokens = commaTokens.substring(0, commaTokens.length() -1 );
    return commaTokens;
  }

  private String getParamTokens(XPath xpath, Node tokensTd) throws XPathExpressionException {
    NodeList tokens = (NodeList) xpath.evaluate( "a", tokensTd, XPathConstants.NODESET);
    // sometimes tokens are not in <a> tags
    if ( tokens.getLength() == 0) {
      String tokensAsTxt = xpath.evaluate( "text()", tokensTd);
      if ( tokensAsTxt.startsWith( "subset of tokens " ) ) {
        return getParamTokens( tokensAsTxt.substring( 17 ) );
      } else {
        return getParamTokens( tokensAsTxt );
      }
    } else {
      String commaTokens = "";
      for ( int k = 0; k < tokens.getLength(); k++ ) {
        String token = xpath.evaluate( "text()", tokens.item(k) );
        commaTokens += token + ",";
      }
      commaTokens = commaTokens.substring(0, commaTokens.length() -1 );
      return getParamTokens( commaTokens );
    }
  }
  
  private void getRuleParams( Rule rule ) {
    StringBuffer output = new StringBuffer( 2048 );
    List<RuleParameter> params = parsedParams.get( rule.getPluginConfigKey() );
    if ( params != null ) {
      paramsAsRubyStmts( params, rule, output );
      System.out.print( output.toString() );
    }
  }
  
  private void paramsAsRubyStmts( List<RuleParameter> params, Rule rule, StringBuffer buffer ) {
    for (RuleParameter ruleParameter : params) {
      buffer.append( "add_rule_parameter(" )
            .append( quotedString( rule.getPluginRuleKey() ) )
            .append( ", ").append( quotedString( rule.getPluginName() ) )
            .append( ", " ).append( quotedString( ruleParameter.name ) )
            .append( ", " ).append( quotedString( ruleParameter.description ) )
            .append( ", " ).append( quotedString( ruleParameter.defaultValue ) )
            .append( ", " ).append( quotedString( ruleParameter.type ) ).append( ")\n" );
    }
  }
  
  private String quotedString( String string) {
    return "\"" + string.replaceAll( "\"", "'") + "\"";
  }
  
  public static void main(String[] args) throws Exception {
    JdbcData jdbcData = new JdbcData( "jdbc:derby://localhost:1527/sonar;create=true", "org.apache.derby.jdbc.ClientDriver", "sonar", "sonar");
    RulesParamsParser parser = new RulesParamsParser( Persistence.create(jdbcData) );
    parser.generateMigrationScript();
  }

  private class RuleParameter {
    String name;
    String description;
    String defaultValue;
    String type;
  }*/
}
