package org.sonar.commons.database;

import org.hibernate.ScrollableResults;
import org.hibernate.SessionFactory;
import org.hibernate.StatelessSession;
import org.hibernate.Transaction;

public class BatchLoader {
  private DatabaseConnector connector;
  private StatelessSession statelessSession = null;
  private Transaction transaction = null;
  private ScrollableResults scroll = null;

  public BatchLoader(DatabaseConnector dc) {
    this.connector = dc;
  }

  public void begin(String hibernateQuery) {
    SessionFactory emf = (SessionFactory) connector.getEntityManagerFactory();
    statelessSession = emf.openStatelessSession();
    transaction = statelessSession.beginTransaction();
    scroll = statelessSession.createQuery(hibernateQuery).scroll();
  }

  public Object next() {
    if (scroll.next()) {
      return scroll.get(0);
    }
    return null;
  }

  // obj is loaded from the method next()
  public void update(Object obj) {
    statelessSession.update(obj);
  }

  public void commit() {
    transaction.commit();
    statelessSession.close();
  }
}